{%- macro submission(submission, options) -%}
  {%- set options = {
    show_body: false,
    show_forum_name: true,
  }|merge(options|default({})) -%}

  {{- block('submission') -}}
{%- endmacro -%}

{%- macro submission_sort(current) -%}
  {%- spaceless -%}
    {%- for type in ['hot', 'new', 'top', 'controversial'] -%}
      <li class="{{ type == current ? 'active' }}">
        <a href="{{ path(app.request.attributes.get('_route'), app.request.attributes.get('_route_params')|default([])|merge({page: 1, sortBy: type})) }}">
          {{- ('submissions.sort_by_'~type)|trans -}}
        </a>
      </li>
    {%- endfor -%}
  {%- endspaceless -%}
{%- endmacro -%}

{%- block submission_info_submitter -%}
  {%- from '@RadditApp/macros/user_macros.html.twig' import user_link -%}
  {{ user_link(submission.user, {
    class: 'submission-submitter',
    flag: submission.userFlag,
  }) }}
{%- endblock -%}

{%- block submission_info_timestamp -%}
  {%- set date = submission.timestamp|localizeddate('long', 'short') -%}
  <time datetime="{{ submission.timestamp|date('c') }}" title="{{ date }}" class="submission-timestamp relative-time">
    {{- 'submissions.info_at_timestamp'|trans({'%timestamp%': date}) -}}
  </time>
{%- endblock -%}

{%- block submission_info_forum_name -%}
  <a href="{{ path('raddit_app_forum', {forum_name: submission.forum.name}) }}" class="submission-forum">
    {{- submission.forum.name -}}
  </a>
{%- endblock -%}

{%- block submission_info_edited_at -%}
  {%- set date = submission.editedAt|localizeddate('long', 'short') -%}
  <time datetime="{{ submission.editedAt|date('c') }}" title="{{ date }}" class="relative-time-diff" data-compare-to="{{ submission.timestamp|date('c') }}">
    {{- 'submissions.info_at_timestamp'|trans({'%timestamp%': date}) -}}
  </time>
{%- endblock -%}

{%- block submission -%}
  {%- from '@RadditApp/macros/votes.html.twig' import vote -%}
  <article class="submission {{ submission.url ? 'submission-has-url' }} {{ submission.body is not null ? 'submission-has-body' }} {{ not options.show_body ? 'submission-body-hidden' }} {{ submission.sticky ? 'submission-sticky' }}">
    <div class="submission-row">
      <div class="submission-vote">
        {{- vote(submission, 'raddit_app_submission_vote') -}}
      </div>

      {% if submission.image %}
        <div class="submission-image-container">
          <a href="{{ block('submission_url') }}" class="submission-image">
            <img src="{{ 'submission_images/%s'|format(submission.image)|imagine_filter('submission_thumbnail') }}" class="submission-thumbnail" alt="">
          </a>
        </div>
      {% endif %}

      <div class="submission-inner">
        <header class="submission-header">
          <h1 class="submission-title">
            <a href="{{ block('submission_url') }}" class="submission-link">
              {{- submission.title -}}
            </a>

            {% if submission.url is not empty and '://' in submission.url %}
              <small class="submission-host">
                {%- with {host: submission.url|split('://')[1]|split('/')[0]} -%}
                  {{- host[0:4] == 'www.' ? host[4:] : host -}}
                {%- endwith -%}
              </small>
            {% endif %}
          </h1>

          <p class="submission-info">
            {%- if options.show_forum_name -%}
              {{ 'submissions.info_with_forum_name'|trans({
                '%submitter%': block('submission_info_submitter'),
                '%timestamp%': block('submission_info_timestamp'),
                '%forum%': block('submission_info_forum_name'),
              })|raw }}
            {%- else -%}
              {{ 'submissions.info_without_forum_name'|trans({
                '%submitter%': block('submission_info_submitter'),
                '%timestamp%': block('submission_info_timestamp'),
              })|raw }}
            {%- endif -%}

            {% if submission.editedAt %}
              <span class="submission-info-edited-at {{ submission.moderated ? 'submission-info-moderated' }}">
                {{ (submission.moderated ? 'submissions.moderator_info' : 'submissions.edit_info')|trans({
                  '%edited_at%': block('submission_info_edited_at')
                })|raw }}
              </span>
            {% endif %}
          </p>
        </header>

        {%- if options.show_body -%}
          {% if submission.url %}
            <div class="submission-media">{{ block('submission_media') }}</div>
          {% endif %}

          {% if submission.body is not null %}
            <div class="submission-body">{{ submission.body|cached_markdown|raw }}</div>
          {% endif %}
        {%- endif -%}

        {%- spaceless -%}
          <nav class="submission-nav">
            <ul>
              <li>
                <a href="{{ path('raddit_app_comments', {forum_name: submission.forum.name, submission_id: submission.id, slug: submission.title|slugify}) }}">
                  {{- 'submissions.comments'|transchoice(submission.comments|length) -}}
                </a>
              </li>
              {%- if is_granted('edit', submission) -%}
                <li>
                  <a href="{{ path('raddit_app_edit_submission', {forum_name: submission.forum.name, submission_id: submission.id}) }}">
                    {{- 'submissions.edit'|trans -}}
                  </a>
                </li>
              {%- endif -%}
              {%- if is_granted('ROLE_ADMIN') -%}
                <li>
                  <a href="{{ path('raddit_app_ban_ip_by_submission', {id: submission.id}) }}">{{ 'submissions.ip_ban'|trans }}</a>
                </li>
              {%- endif -%}
            </ul>
          </nav>
        {%- endspaceless -%}
      </div>
    </div>
  </article>
{% endblock %}

{%- block submission_url -%}
  {%- if submission.url -%}
    {{- submission.url -}}
  {%- else -%}
    {{- path('raddit_app_comments', {forum_name: submission.forum.name, submission_id: submission.id, slug: submission.title|slugify}) -}}
  {%- endif -%}
{%- endblock -%}

{%- block submission_media -%}
  {# TODO #}
{%- endblock -%}
